
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author hoffmann
 */
public class FASTAReader {

    public HashMap<String,String> read(File f) {
        HashMap<String,String> sequences = new HashMap<String,String>();
        try {
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(f)));
			String line = "";
			StringBuilder blockBuilder = new StringBuilder(128);
			String sname = "";
			try {
				//Read one line of input
				while((line=br.readLine())!=null) {
					//Init new Sequence after comment line
					if(line.startsWith(">")) {
						//postprocess if we have attached all lines
						if(blockBuilder.length()>0) {
							sequences.put(sname,blockBuilder.toString());
                                                        //reset blockBuilder
							blockBuilder = new StringBuilder(128);
						}
						sname = line.substring(line.indexOf(">")+1);
					} else {
						//process line and add to return list
						line.trim();
						if(!line.isEmpty()) {
							blockBuilder.append(line);
						}
					}
				}
				//catch the last block in a file
				if(blockBuilder.length()>0) {
					sequences.put(sname,blockBuilder.toString());
				}
			} catch (IOException e) {
				System.err.println(e.getLocalizedMessage());
			}
		} catch (FileNotFoundException e) {
			System.err.println("File not found: "+f.getAbsolutePath());
			System.err.println(e.getLocalizedMessage());
		}
		return sequences;
    }

    public static void main(String[] args) {
        if(args.length>0) {
                //Create a new FASTAParser of type AminoacidAlphabet
                FASTAReader fp = new FASTAReader();
                for(String s:args) {
                    HashMap<String,String> sequences = fp.read(new File(s));
                    for(String seqID:sequences.keySet()) {
                        System.out.println("> "+seqID);
                        System.out.println(sequences.get(seqID));
                    }
                }
        } else {
                System.out.println("Usage: java "+FASTAReader.class.getName()+" sequenceData1.fasta [sequenceData2.fasta [...]]");
                System.exit(-1);
        }
    }

}
